#!/bin/sh
SCRIPT_FILE="DoIT.sh"
. ../target.def 

if [ -f libpcap-0.7.2/bpf_filter.c ]; then
	echo "libpcap ok"
else
	tar xzvf libpcap-0.7.2.tgz
fi

if [ -f gmp-4.1/gmp-mparam.h ]; then
	echo "gmp ok"
else
	tar xzvf gmp-4.1.tgz
fi

if [ $# -gt 2 ]; then
	echo "usage $0 [make|clean|config] [ap|gw|ga]"
	exit 1
fi

case "$1" in
	"make")
		export MAKING=1
		export MAKECLEAR=0
		MAKING_IMG=1
		;;
	"clean")
		export MAKING=0
		export MAKECLEAR=1
		MAKING_IMG=0
		;;
	"config")
		export MAKING=0
		export MAKECLEAR=1
		export MAKCONFIG=1
		MAKING_IMG=0
		;;
    *)
        echo "usage $0 [make|clean|config] [ap|gw|ga]"
        exit 1
        ;;								
esac

if [ $# = 2 ]; then
	case "$2" in
		"ap")
			TYPE=ap
			;;
		"gw")
			TYPE=gw
			;;
		"ga")
			TYPE=ga
			;;
		*)
			echo "usage $0 [make|clean|config] [ap|gw|ga]"
			exit 1
			;;
	esac
fi								

if [ "$TYPE" = "" ]; then
	if [ "$1" != "clean" ]; then
		echo "usage $0 [make|clean|config] [ap|gw|ga]"
		exit 1
	fi
fi

for DIR in $(ls); do
    if [ -d $DIR ]; then
		cd $DIR
		if [ -f $SCRIPT_FILE ]; then
		    echo ""
			echo "******************** Compiling $DIR ********************"
			echo ""
			./$SCRIPT_FILE $TYPE
			if [ $? = 0 ]; then
				echo ""
				echo "******************** End compile $DIR ********************"
				echo ""
			else
                echo ""
                echo "******************** compile ERROR in $DIR !! ********************"
                echo ""
				exit 1
			fi
		fi
		cd ..
	fi
done

if [ "$MAKING_IMG" = "1" ]; then
	echo ""
	echo "******************** Making appimg ********************"
	echo ""
	cd $AP_PATH/mkimg

	case "$MODEL" in
		"-D_EW-7209APg_")
				echo "******************** Making appimg EW-7209APg ********************"
				./mk11g
				;;
		*)

				echo "******************** Model not found  ********************"
				exit 1
				;;
	esac

	if [ $? = 0 ]; then
		echo ""
		echo "******************** Make appimg OK !! ********************"
		echo ""
	else
		echo ""
	    echo "******************** Make appimg FAIL !! ********************"
		echo ""
		exit 1
	fi
fi

echo ""
echo "******************** Script finished !! ********************"
echo ""


