/*
 * Realtek RT8181 write system image to flash
 *
 * Copyright (C) 2004 Tom Vrana <tom@voda.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */


#include <stdlib.h>                                                                                                        
#include <sys/types.h>                                                                                                     
#include <sys/stat.h>                                                                                                      
#include <fcntl.h>                                                                                                         
#include <unistd.h>                                                                                                        
#include <string.h>                                                                                                        
#include <stdio.h>

int main(int argc, char** argv)                                                                                            
{
	unsigned long i;
	int offset=0x10000;
	int fout,finp;
	int buffsize=1024*100;

	char *buffer, *finame;
	
	finame = (char*)malloc(256);

	if ( argc!=2 ) {                                                                                                   
                printf("flw requires filename of file to store\n");                                                              
                exit(1);                                                                                                  
        }
	sscanf(argv[1], "%s", finame);

// open files
	finp = open (finame, O_RDONLY);
	if (finp == -1) {
		printf ("opening input file failed !\n");
		exit(1);
	}

	fout = open ("/dev/mtd", O_RDWR);
	if (fout == -1) {
		printf ("opening output file failed !\n");
		exit(1);
	}


// move offset
	printf ("seeking... ");
	lseek (fout,offset,SEEK_SET);
	buffer = (char*) malloc(buffsize);
	i=0;
	printf ("writing ");
	while ( read( finp, buffer, buffsize) != 0 ) {
		write (fout, buffer, buffsize);
		i++;
		printf (".");
	}
	
	printf(" wrote: %d 100k blocks \n",i);
	printf(" please wait until buffers are emptied\n");

	free (buffer);
	free (finame);

	exit(0);
}
