/*
 * Realtek RT8181 write config to flash
 *
 * Copyright (C) 2004 Tom Vrana <tom@voda.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */
 
#include <stdlib.h>                                                                                                        
#include <sys/types.h>                                                                                                     
#include <sys/stat.h>                                                                                                      
#include <fcntl.h>                                                                                                         
#include <unistd.h>                                                                                                        
#include <string.h>                                                                                                        
#include <stdio.h>

int main(int argc, char** argv)                                                                                            
{
	unsigned long i;
	unsigned long *pi;
	int offset=0x00C000;
	int maxsize=0x010000-0x00C000-sizeof(i);
	int fout,finp;
	int retval=0;

	char *buffer, *mode, *finame;
	char m_set[3],m_get[3],m_erase[5];
	
	strcpy(m_get,"get");
	strcpy(m_set,"set");	
	strcpy(m_erase,"erase");	

	mode =  (char*)malloc(256);
	finame = (char*)malloc(256);

	if ( argc < 2 ) {                                                                                                          
        	printf("usage: storecfg set|get|erase\n");   
        	exit(1);                                                                                                           
	}                                                                                                                        
  	sscanf(argv[1], "%s", mode);                                                                     
	
	fprintf(stderr,"running %s mode\n",mode);	
	pi = &i;

if (strcmp(mode,m_set)== 0 ) {

	if ( argc!=3 ) {                                                                                                   
                printf("set mode requires filename of file to store\n");                                                              
                exit(1);                                                                                                  
        }
	sscanf(argv[2], "%s", finame);

// open files
	finp = open (finame, O_RDONLY);
	if (finp == -1) {
		printf ("opening input file failed !\n");
		exit(1);
	}

	fout = open ("/dev/mtd", O_RDWR);
	if (fout == -1) {
		printf ("opening output file failed !\n");
		exit(1);
	}


// move offset
	lseek (fout,offset+sizeof(i),SEEK_SET);

	buffer = (char*) malloc(1);
	i=0;
	while ( read( finp, buffer, 1) != 0 && i < maxsize ) {
		write (fout, buffer, 1);
		i++;
	}
	if (i == maxsize) {
		printf ("data too large, cut off at %d bytes", maxsize);
		retval = 1;
	} else {
		printf("wrote: %d bytes \n",i);
	}
	lseek (fout,offset,SEEK_SET);
	write (fout,pi,4); 	
	sync();
	close(fout);
	close(finp);
}

if (strcmp(mode, m_get)==0) {
	finp = open ("/dev/mtd", O_RDONLY);
	if (finp == -1) {
		fprintf (stderr,"opening input file failed !\n");
		exit(1);
	}
	lseek ( finp, offset, SEEK_SET);
	read (finp, pi, 4);
	if (i > 64000) {
	 	printf ("no data in flash  !\n");
	        exit(1);
	}
	fprintf(stderr,"will read: %d bytes \n",i);
	
	buffer = malloc	(i);
	read (finp,buffer,i);
	write (1,buffer,i);	
	close(finp);
}

if (strcmp(mode,m_erase)== 0 )
{
	fout = open ("/dev/mtd", O_RDWR);
	if (fout == -1) {
		printf ("opening output file failed !\n");
		exit(1);
	}


	lseek (fout,offset+sizeof(i),SEEK_SET);
	buffer = (char*) malloc(1);
	buffer[0]=0;
	i=0;
	while ( i < maxsize ) {
		write (fout, buffer, 1);
		i++;
	}
	printf("wrote: %d bytes \n",i);
	i=0;
	lseek (fout,offset,SEEK_SET);
	write (fout,pi,4); 	
	sync();
	close(fout);
}

	free (buffer);
	free (mode);
	free (finame);

	exit(retval);
}
